//+------------------------------------------------------------------+
//|                                                         HiLo.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red

extern int timeFrame;
double Hi[], Lo[];

string indicatoFileName;
int init()
{
   timeFrame = MathMax(timeFrame,_Period);
   indicatoFileName = WindowExpertName();
 IndicatorShortName("HiLo oscillator");
 IndicatorDigits(Digits);
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(0,Hi);
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(1,Lo);

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
   int countedBars = IndicatorCounted();
      if(countedBars<0) return(-1);
      if(countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
 int pos;
   if (timeFrame!=_Period)
   {
      limit = MathMin(MathMax(limit,3*timeFrame/_Period),Bars-1);
      for (pos=limit; pos>=0; pos--)
      {
         int y = iBarShift(NULL,timeFrame,Time[pos]);
         Hi[pos] = iCustom(NULL,timeFrame,indicatoFileName,0,0,y);
         Lo[pos] = iCustom(NULL,timeFrame,indicatoFileName,0,1,y);
      }
      return(0);
   }
 pos=limit;
 while(pos>=0)
 {
  if (pos==Bars-2)
  {
   Hi[pos]=0.;
   Lo[pos]=0.;
  }
  else
  {
   if (High[pos]>High[pos+1])
   {
    Hi[pos]=Hi[pos+1]+1.;
   }
   else
   {
    Hi[pos]=0.;
   }
   
   if (Low[pos]<Low[pos+1])
   {
    Lo[pos]=Lo[pos+1]+1.;
   }
   else
   {
    Lo[pos]=0.;
   }
  }

  pos--;
 } 
 return(0);
}

